uniform sampler2D u_texture0;
uniform sampler2D u_textureBackdrop;

precision mediump float;

uniform vec4 u_TxGrid;
uniform vec4 u_TargetGrid;
// top, bottom, left, right
//  x     y       z     w

varying vec2 v_texCoords;

void main()
{
    vec4 v4BackDrop = texture2D(u_textureBackdrop, v_texCoords);

    float fX = v_texCoords.x;
    float fY = v_texCoords.y;
    if(v_texCoords.x <= u_TargetGrid.z)
    {
        fX = v_texCoords.x / u_TargetGrid.z * u_TxGrid.z;
    }
    else if(v_texCoords.x >= u_TargetGrid.w)
    {
        fX = (v_texCoords.x - u_TargetGrid.w) / (1.0 - u_TargetGrid.w) * (1.0 - u_TxGrid.w) + u_TxGrid.w;
    }
    else
        fX = u_TxGrid.z;

    if(v_texCoords.y <= u_TargetGrid.x)
    {
        fY = v_texCoords.y / u_TargetGrid.x * u_TxGrid.x;
    }
    else if(v_texCoords.y >= u_TargetGrid.y)
    {
        fY = (v_texCoords.y - u_TargetGrid.y) / (1.0 - u_TargetGrid.y) * (1.0 - u_TxGrid.y) + u_TxGrid.y;
    }
    else
        fY = u_TxGrid.x;

	vec4 v4Frame = texture2D(u_texture0, vec2(fX, fY));
	gl_FragColor = vec4(mix(v4BackDrop, v4Frame, v4Frame.a).rgb, 1.0);
}
