
uniform sampler2D u_texture0; 
uniform sampler2D gaussianTableTexture;

precision mediump float;

uniform highp float texelWidthOffset;
uniform highp float texelHeightOffset;
uniform int blurSize;
uniform vec4 u_ShadowColor;
varying vec2 v_texCoords;

void main()
{
    vec2 singleStepOffset = vec2(texelWidthOffset, texelHeightOffset);
    vec2 blurOffset;
    vec4 sum = vec4(0.0);
    vec4 v4GaussianWeight = texture2D(gaussianTableTexture, vec2(0.0, 0.0));
    float fGaussianWeight = v4GaussianWeight.r + v4GaussianWeight.g / 256.0;
    sum = texture2D(u_texture0, v_texCoords) * fGaussianWeight;

    float fSize = float(blurSize);
    for(int index = 1 ; index <= blurSize ; index++)
    {
        v4GaussianWeight = texture2D(gaussianTableTexture, vec2(float(index) / fSize, 0.0));
        fGaussianWeight = v4GaussianWeight.r + v4GaussianWeight.g / 256.0;

        blurOffset = singleStepOffset * float(index);
        sum += texture2D(u_texture0, v_texCoords + blurOffset) * fGaussianWeight;
        sum += texture2D(u_texture0, v_texCoords - blurOffset) * fGaussianWeight;
    }

    gl_FragColor = vec4(u_ShadowColor.rgb, sum.a * u_ShadowColor.a);
}